> For the complete documentation index, see [llms.txt](https://docs.defisaver.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.defisaver.com/actions/lido/lidostake.md).

# LidoStake

### Description

Supplies ETH (action receives WETH) to Lido for ETH2 Staking. Receives stETH in return

> **Notes**
>
> Pulls weth, transforms it into eth, stakes it with lido, receives stEth and sends it to target address.\
> Receiving address may find itself with 1-2 less wei than amount sent (received from staking) due to lido rounding error.

### Action ID

`0xd7e40b2d`

### SDK Action

```ts
const lidoStakeAction = new dfs.actions.lido.LidoStakeAction(
    amount,
    from,
    to
);
```

### Action Type

`STANDARD_ACTION`

### Input Parameters

```solidity
    /// @param amount - amount of WETH to pull
    /// @param from - address from which to pull WETH from
    /// @param to - address where received stETH will be sent to
    struct Params {
        uint256 amount;
        address from;
        address to;
    }
```

### Return Value

```solidity
return
contract LidoStake is ActionBase, DSMath, LidoHelper {
    using TokenUtils for address;
```

### Events and Logs

```solidity
emit ActionEvent("LidoStake", logData);
logger.logActionDirectEvent("LidoStake", logData);
bytes memory logData = abi.encode(params);
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.defisaver.com/actions/lido/lidostake.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
